import Eval.Term

data M a       = Raise Exception | Return a deriving Show
type Exception = String

instance Monad M where
  return x = Return x
  
  m >>= f = case m of
    Raise e  -> Raise e
    Return x -> f x

raise :: Exception -> M a
raise e = Raise e

eval :: Term -> M Int
eval (Con a)   = return a
eval (Div t u) = do
  a <- eval t
  b <- eval u
  if b == 0 then raise "divide by zero"
            else return (a `div` b)
