import Eval.Term
newtype M a = M { run :: State -> (a, State) }
type State  = Int

instance Monad M where
  return a = M (\x -> (a, x))
  
  m >>= f = M (\x -> let (a, y) = run m x     in
                     let (b, z) = run (f a) y in
                     (b, z))

tick :: M ()
tick = M (\x -> ((), x+1))

eval :: Term -> M Int
eval (Con a)   = return a
eval (Div t u) = do {
  a <- eval t; b <- eval u;
  tick; return (a `div` b)
}
