import Eval.Term 

newtype M a = M { run :: (Output, a) } deriving Show
type Output = String

instance Monad M where
  return a = M ("", a)
  
  m >>= f = let (x, a) = run m     in
            let (y, b) = run (f a) in
            M (x ++ y, b)

out :: Output -> M ()
out x = M (x, ())

line :: Term -> Int -> Output
line t a = "eval(" ++ show t ++ ") <= " ++ show a ++ "\n"

eval (Con a)   = do { out (line (Con a) a); return a }
eval (Div t u) = do {
  a <- eval t; b <- eval u;
  out(line(Div t u) (a `div` b)); return(a `div` b) }
